export interface libsodiumSymbolIO {
    name: string;
    optional?: boolean;
    size?: string;
    type: string;
}
export interface libsodiumSymbol {
    assert_retval?: [{
        condition: string;
        or_else_throw: string;
    }];
    dependencies?: Array<string>;
    inputs?: Array<libsodiumSymbolIO>;
    name: string;
    noOutputFormat?: boolean;
    outputs?: Array<libsodiumSymbolIO>;
    return?: string;
    target?: string;
    type: 'function';
}
export default class TypeGenerator {
    outputFileOrDir: string;
    private libsodiumLocalSource;
    private constants;
    private libsodiumVersion;
    private sourceIsSet;
    private tmpDir;
    private readonly additionalSymbols;
    private readonly enums;
    private readonly genericTypes;
    private readonly types;
    constructor(outputFileOrDir: string, libsodiumLocalSource?: string);
    setDownloadVersion(version: string): Promise<TypeGenerator>;
    private readonly externalLibsodiumSource;
    private downloadLibrary();
    getVersion(): string;
    private getFunctions();
    private getConstants();
    private convertType(type);
    private convertReturnType(type);
    private buildData(sumo?);
    generate(sumo?: boolean): Promise<string>;
    generateStandard(): Promise<string>;
    generateSumo(): Promise<string>;
}
